#ifndef _CG_HH_
#define _CG_HH_

#include <list>
#include "c.hh"
#include "archi.hh"
#include "tp.hh"
#include "pu.hh"
#include "sched.hh"
#include "emit.hh"
#include "flags.hh"

class CG {

public:
  CG();
  ~CG() {}
  static void initialize(int, char **);
  static void finalize(void);
  void function(lcc::Symbol, lcc::Symbol *, lcc::Symbol *, int);
  lcc::Node gen(lcc::Node);
  void emit(lcc::Node, char *);  //Archi

  //  typedef enum { TIME, ENERGY, LST } opt_type_t;
private:

//  void mark_dfs(lcc::Node, basic_block_id, node_id = NOPARENT);
//  void dfs(lcc::Node);
//  void select(const INDEG, const Z, const lcc::Node, INDEG *, Z *);
//  void print_graph(void);
//  void vcg(const GRAPH);
//  void vcg(const DAG);
  //  void build_dag(lcc::Node, DAG &);

  static Flags flags;

  //  static void usage(void);

  static bool b_initialized;
//   static bool b_vcg;
//   static bool b_dot;
//   static int i_bb;
//   static int i_hs;
//   static int i_ts; //Heurisic for transfers

  static Architecture *architecture;
  static Emitter *emitter;
  short rank;

  //PU *pu;

  static char* archi;
  static TimeProfile *empty_time_profile;
  //  static SolutionSpace *solution_space;

//  static const node_id NOPARENT = 0xffffffff;

  //DAG dag;
  //node_id_map_t node_id_map;
  std::list< std::pair< Schedule *, DAG * > > schedule;

  //  static opt_type_t opt_type;

};

#endif //_CG_HH_
