#include "ilpd.hh"

ILPD::ILPD(DAG _dag, std::ofstream & _f)
{
  graph_traits< DAG >::vertex_iterator vi, vi_end;
  graph_traits< DAG >::edge_iterator ei, ei_end;
  lcc::Node p;

  _f << "param: G : OPG ODG :=" << std::endl;
  for(tie(vi, vi_end) = vertices(_dag); vi != vi_end; ++vi) {
    p = get_lcc_node(*vi, _dag);
    successor_iterator pi, pi_end;
    int outdeg = 0;
    for(tie(pi, pi_end) = successors(*vi, _dag); pi != pi_end; ++pi) {
      outdeg++;
    }
    //Node id
    _f << "  " << *vi  
      //Operator id
       << "\t" << p->op 
      //Node out-degree
       << "\t" <<  outdeg
      //Node name
       << "\t# " << lcc::opname(p->op) 
       << std::endl;
  }
  _f << ";" << std::endl << std::endl;

  _f << "set EG :=" << std::endl;
  for(tie(ei, ei_end) = edges(_dag); ei != ei_end; ++ei) {
    size_t p_id = source(*ei,_dag), q_id = target(*ei,_dag);
    _f << "  (" << p_id << "," << q_id << ")" << std::endl;
  }
  _f << ";" << std::endl << std::endl;
}

ILPD::~ILPD()
{
}
