#ifndef __PU_HH__
#define __PU_HH__

/***
 * Processing unit --- The Processing Unit for OPTIMIST is the forest of DAGs.
 * LCC includes CALL as subnodes. This is broken in the PU.
 */

#include "c.hh"
//#include <vector>
//#include <map>
#include <stack>
#include "pudag.hh" 
#include "archi.hh"
#include "flags.hh"


class PU {
	
public:

  PU(lcc::Node, Architecture *, Flags &);
  ~PU();
  std::vector< DAG *> & get_dags(void) { return dags; }
  void print(bool _vcg = true, bool _dot = true);
  
private:
		
  vertex_id get_vertex_id(lcc::Node, DAG &);
  void build_dag(lcc::Node, int, DAG &);
	
  typedef std::map< lcc::Node, vertex_id > node_id_map_t;
  typedef std::map< DAG *, node_id_map_t > dag_nodes_map_t;
  typedef std::vector< DAG * > DAGS;

  dag_nodes_map_t dag_nodes_map;
  DAGS dags;
  DAG *current_dag;
	
  typedef std::vector< std::pair< int, vertex_id > > deps_t;
  void find_deps(int, lcc::Node, DAG &, deps_t &, vertex_id _predecessor = (vertex_id)-1);

  Architecture *architecture;
};

#endif //__PU_HH__
