#ifndef _TINST_HH_
#define _TINST_HH_

//#include "c.hh"
#include <iostream>
#include <vector>
#include <map>

typedef std::vector< bool > bit_vector_t;
typedef std::vector< bit_vector_t > reserv_tab_t;
const int STMT_RC = -2; //Statements do not need a residence (negative)
//FIXME common

struct ltstr {
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) < 0;
  }
};


class TargetInstruction {

public:
  //For instruction (one to one mapping)
  TargetInstruction(char *, reserv_tab_t *, int _dest1, int _src1, int _src2, char *_format,
		    float, std::vector< int > &, char *_constraint = 0);
  //For pattern
  TargetInstruction(char *, reserv_tab_t *, std::map< char *, int, ltstr > &, char * _format,
		    float, std::vector< int > &, char *_constraint = 0);
  TargetInstruction(const TargetInstruction & _t_instr);
  ~TargetInstruction();
  void print(void) { std::cout << mnemonic << std::endl; }
  const reserv_tab_t & get_reserv_tab(void) const { return *reserv_tab; }
  int get_residence_class(char *_rc_name);
  //char *get_residence_class(int _index) { return ops_map[_index]; }
  float get_base_cost(void);
  friend std::ostream & operator<<(std::ostream &, const TargetInstruction &);
  std::vector< int > get_use_funits(void);

private:
  //map name of the operand id to int (to residence class)
  typedef std::map< char *, int, ltstr > ops_map_t;
  ops_map_t ops_map;
  char *mnemonic;
  reserv_tab_t *reserv_tab;

  //For energy
  float base_cost;
  std::vector< int > fus;
  static char *dest1;
  static char *src1;
  static char *src2;
  int cond_index;

public:
  char *format; //with op names ex. "\t add {dest1},[{src2}],{dest1};"
  const char *get_mnemonic() { return mnemonic; }
  void set_cond_index(int _cond_index) { cond_index = _cond_index; }
  int get_cond_index(void) { return cond_index; }

private:
  //Constraints on chaining. Right now we can only specify a destination as being 
  //the same result as one of sources
  //We can only specify dest1 = "some_source"
  char *dest1_is;
public:
  char *get_dest1_is(void) { return dest1_is; }

};

std::ostream & operator<<(std::ostream &, const TargetInstruction &);

#endif //_TINST_HH_
