/* Copyright Microsoft Corporation. All rights reserved. */

int ARM_ASSEMBLER_MODE = 0; /* declared in emit.cc */
int OPT_C_DEBUG = 0;
#include "c.h"
/* #include <time.h> */

#define I(f) opt_##f
static char rcsid[] = "$Id: opt.c,v 1.5 2004/11/26 12:30:59 x04anded Exp $";

/* static const char *uname;	/\* unique name prefix *\/ */
/* static int maxstack;		/\* maximum amount of stack space used, in bytes *\/ */
static int maxlocals;		/* maximum amount of local space used, in bytes */
/* static Table ILtypes;		/\* generated MSIL types *\/ */

//typedef short *Indeg;            /* Indegrees */
extern Node cg_gen(Node); //, Indeg);
extern void cg_emit(Node, char *); //Indeg, char *);
extern void cg_function(Symbol, Symbol*, Symbol*, int);
extern void cg_initialize(int, char **);
extern void cg_finalize(void);

//static Indeg indeg;

static void I(segment)(int n) { 
  if(OPT_C_DEBUG)
    print("@segment %d\n",n);
  if(ARM_ASSEMBLER_MODE)
  {
    switch(n)
    {
	case CODE:
	  print(".text\n");
	  break;
	case BSS:
	  print(".bss\n");
	break;
	case DATA:
	  print(".data\n");
	  break;
	case LIT: /* possibly .text as well */
	  print(".data\n");
	  break;
	default:
	  print("UNKNOWN SEGMENT SWITCH\n");
    }
  }
}
static void I(blockbeg)(Env *e) { 
  if(OPT_C_DEBUG)
    print("@blockbeg\n"); 
}
static void I(blockend)(Env *e) {
  if(OPT_C_DEBUG)
    print("@blockend\n"); 
}

/* address - initialize q for addressing expression p+n */
static void I(address)(Symbol q, Symbol p, long n) { 
  if(OPT_C_DEBUG)
    print("@address\n"); 
}
/* 	q->name = p->name; */
/* 	q->x.name = p->x.name; */
/* 	q->x.offset = n; */
/* 	q->type = p->type; */
/* } */

//#define print printstr
static void I(defaddress)(Symbol p) { 
  if(OPT_C_DEBUG)
    print("@defaddress\n");
}

/* 	if (lc > 0) */
/* 		print(",\n"); */
/* 	if (!isfunc(p->type) && (!p->computed || p->x.offset == 0)) */
/* 		print("&(%s)", datalabel(p)); */
/* 	else { */
/* 		initbuffer = appendstr(initbuffer, */
/* 			"ldsflda %s %s\n" */
/* 			"ldc.i4 %d\n" */
/* 			"add\n", gettype(current->type), current->x.name, lc); */
/* 		if (isfunc(p->type)) */
/* 			initbuffer = appendstr(initbuffer, */
/* 				"ldftn %s\n" */
/* 				"stind.i4\n", signature(p->type, p->x.name)); */
/* 		else */
/* 			initbuffer = appendstr(initbuffer, */
/* 				"ldsflda %s %s\n" */
/* 				"ldc.i4 %d\n" */
/* 				"add\n" */
/* 				"stind.i4\n", gettype(p->type), p->x.name, p->x.offset); */
/* 		print("int%d (0)", 8*voidptype->size); */
/* 	} */
/* 	lc += voidptype->size; */
/* } */


static void I(defconst)(int suffix, int size, Value v) {
  if(OPT_C_DEBUG)
    print("@defconst\n");
  if(ARM_ASSEMBLER_MODE)
  {
    switch(suffix)
    {
       case I:
	 print("\t.word\t%d\n",v.i); /* only for integers*/
	 break;
	case P:
	  print("\t.word\t$_%s\n",v.p);
	  break;
	default:
	  print("\t.some constant.....?\n");
   }
  }
}
/* 	if (lc > 0) */
/* 		print(",\n"); */
/* 	switch (suffix) { */
/* 	case I: print("int%d (%d)", 8*size, v.i); break; */
/* 	case U: print("int%d (%u)", 8*size, (long)v.u); break; */
/* 	case P: print("int%d (%p)", 8*size, v.p); break; */
/* 	case F: print("float%d (%s)", 8*size, tostring(v.d)); break; */
/* 	default: assert(0); */
/* 	} */
/* 	lc += size; */
/* } */

static void I(defstring)(int len, char *str) { 
  if(OPT_C_DEBUG)
    print("@defstring %s\n",str);
  if(ARM_ASSEMBLER_MODE)
  {
    int i;
    print("\t.ascii\t\"");
    for(i=0;i<len-1;i++)
    {
      if(str[i]=='\n')
	print("\\n");
      else
	print("%c",str[i]);
    }
    print("\\000\"\n");
  }
}
/* 	int i; */

/* 	if (lc > 0) */
/* 		print(",\n"); */
/* 	print("bytearray ("); */
/* 	for (i = 0; i < len; i++) { */
/* 		if (i > 0 && i%30 == 0) */
/* 			print("\n"); */
/* 		print(" %x", (unsigned char)str[i]); */
/* 	} */
/* 	print(" )"); */
/* 	lc += len; */
/* } */
/* #undef print */

static void I(space)(int n) { 
  if(OPT_C_DEBUG)
    print("@space %d\n",n);
  if(ARM_ASSEMBLER_MODE) 
    print("\t.space %d\n",n);
}
/* 	static Value v = { 0 }; */

/* 	for ( ; n >= 4; n -= 4) */
/* 		(*IR->defconst)(I, 4, v); */
/* 	for ( ; n >= 2; n -= 2) */
/* 		(*IR->defconst)(I, 2, v); */
/* 	for ( ; n >  0; n -= 1) */
/* 		(*IR->defconst)(I, 1, v); */
/* } */

static void I(defsymbol)(Symbol p) { 
  char *uname="";
  if(OPT_C_DEBUG)
    print("@defsymbol %s\n",p->name);
  
  if(ARM_ASSEMBLER_MODE)
  {
    if (p->scope == CONSTANTS )
      p->x.name = p->name;
    else if (p->sclass == STATIC && p->generated)
      p->x.name = stringf("$%s_%s", uname, p->name);
    else if (p->sclass == STATIC)
      p->x.name = stringf("$%s%d_%s", uname, genlabel(1), p->name);
    else if (p->scope == LABELS)
      p->x.name = stringf("$L%s", p->name);
    else if (p->generated)
      p->x.name = stringf("$%s", p->name);
    else
      p->x.name = stringf("%s", p->name);
  }
  else
    p->x.name = stringf("%s", p->name);
}

static void I(global)(Symbol p) {
  if(OPT_C_DEBUG)
    print("@global %s\n",p->name);
  if(ARM_ASSEMBLER_MODE)
  {
    print(".text\n");
    
    print(".%s:\n\t.word %s\n",p->x.name,p->x.name);
    
    I(segment)(p->u.seg);
    
    /*print("\t.align\t%d\n",2);*/
    /*print("\t.type\t%s,object\n",p->x.name);*/
    /*print("\t.size\t%s,%d\n",p->x.name,p->type->size);*/
    print("%s:\n",p->x.name);
  }
}
/* 	closedata(); */
/* 	gettypename(p->type); */
/* 	print(".field public static %s %s at %s\n", gettype(p->type), p->x.name, datalabel(p)); */
/* 	current = p; */
/* } */

static void I(emit)(Node p) {
  cg_emit(p, "archi.xml"); //indeg, "archi.xml");
}

static void I(local)(Symbol p) {
  if(OPT_C_DEBUG)
    print("@local %s, %d bytes\n",p->name,p->type->size);
  
  p->x.offset = 12+p->type->size+maxlocals;
  maxlocals = roundup(maxlocals + p->type->size, 4);
  p->x.name = p->name;
  /*	locals = append(p, locals);
	if (isarray(p->type) && p->type->type->size > 0)
	 emittype(stringf("%s[%d]", gettypename(p->type->type),
	          p->type->size/p->type->type->size), p->type);
	else
  	 gettypename(p->type);*/
}

static void I(export)(Symbol p) {
  if(OPT_C_DEBUG)
    print("@export %s\n",p->name);
  if(ARM_ASSEMBLER_MODE)
    print("\t.global %s\n",p->x.name); 
}

/* static int reg, argcount, argno; */

static void I(function)(Symbol f, Symbol caller[], Symbol callee[], int ncalls) {
  if(OPT_C_DEBUG)
    print("@function\n");
  
  cg_function(f, caller, callee, ncalls);

  maxlocals = 0;
  {
    int i;
    for (i = 0; caller[i] && callee[i]; i++) { 
      caller[i]->x.offset = i; 
      callee[i]->sclass = caller[i]->sclass; 
      
      /* set offsets */
      caller[i]->x.offset = maxlocals+16;
      callee[i]->x.offset = maxlocals+16;
      maxlocals = roundup(maxlocals+caller[i]->type->align, 4);
    }
  }
  
  /* initialize */

/* 	int i; */

/* 	closedata(); */
/* 	maxstack = maxlocals = 0; */
/* 	for (i = 0; caller[i] && callee[i]; i++) { */
/* 		caller[i]->x.offset = i; */
/* 		callee[i]->sclass = caller[i]->sclass; */
/* 		callee[i]->x.offset = i; */
/* 	} */
/* 	reg = 0; */
  gencode(caller, callee);
/* 	print(".method public hidebysig static %s cil managed {\n", signature(f->type, f->x.name)); */
/* 	{ */
/* 		Symbol *argv = ltov(&locals, FUNC); */
/* 		for (i = 0; argv[i] != NULL; i++) { */
/* 			print(".locals ([%d] ", argv[i]->x.offset); */
/* 			if (isarray(argv[i]->type) && argv[i]->type->type->size > 0) */
/* 				print("valuetype '%s[%d]'", gettypename(argv[i]->type->type), */
/* 				      argv[i]->type->size/argv[i]->type->type->size); */
/* 			else */
/* 				print("%s", gettype(argv[i]->type)); */
/* 			print(" '%s')\n", argv[i]->name); */
/* 		} */
/* 	} */
/* 	assert(maxstack%4 == 0); */
/* 	maxstack = roundup(maxstack, voidptype->size); */
/* 	print(".maxstack %d\n", maxstack/voidptype->size); */

  if(ARM_ASSEMBLER_MODE)
  {
    print("\t.align\t%d\n",2);
    print("\t.type\t%s,function\n",f->name);
    print("%s:\n",f->name);
    
    print("\tmov ip, sp\n");
    print("\tstmfd\tsp!, {r4, r5, fp, ip, lr, pc}\n");
    print("\tsub fp, ip, #4\n");
    print("\tsub sp, sp, #%d\n",maxlocals);
    
    /* store formal to memory */
    {
      int j;
      for (j = 0; caller[j] && callee[j]; j++) { 
	/* om callee->type->size r mindre n 4 byte s 
	   ska det INTE vara s hr, exempelvis characters */
	/*	if( callee[j]->type->size == 4 )*/
	  print("\tstr\tr%d, [fp, #-%d]\n",j,caller[j]->x.offset);
	/*	else if( callee[j]->type->size == 1 )
	  print("\tstrb\tr%d, [fp, #-%d]\n",j,caller[j]->x.offset);
	else
	print("\tstore formal %d to memory\n",j);*/
      }
    }
    
    
    print("\n");
  }
  
  emitcode();
  
  if(ARM_ASSEMBLER_MODE)
  {
    print("\tldmea\tfp, {r4, r5, fp, sp, pc}\n");
    {
      static int end_label_id=1;
      print(".Lfe%d:\n",end_label_id);
      print("\t.size\t%s,.Lfe%d-%s\n",f->name,end_label_id,f->name);
      end_label_id++;
    }
  }
  
/* 	print("ret\n}\n"); */
}



static Node I(gen)(Node p) {
  return cg_gen(p); //, indeg);
/* 	head.x.next = head.x.prev = &head; */
/* 	argcount = 0; */
/* 	for ( ; p != NULL; p = p->link) { */
/* 		visit(p); */
/* 		if (generic(p->op) == CALL && p->op != CALL+V) { */
/* 			p->x.listed = 1; */
/* 			reg -= opsize(p->op); */
/* 		} */
/* 	} */
/* 	assert(argcount == 0); */
/* 	head.x.prev->x.next = NULL; */
/* 	for (p = head.x.next; p != NULL; p = p->x.next) */
/* 		switch (generic(p->op)) { */
/* 		case ADDRG: gettype(p->syms[0]->type); break; */
/* 		case INDIR: case ASGN: */
/* 			if (generic(p->kids[0]->op) == ADDRG) */
/* 				gettype(p->kids[0]->syms[0]->type); */
/* 			break; */
/* 		} */
/* 	return head.x.next; */
}

static void I(import)(Symbol p) { 
  if(OPT_C_DEBUG)
    print("@import\n");
/* 	closedata(); */
}

static void I(progbeg)(int argc, char *argv[]) {
  if(OPT_C_DEBUG)
    print("@progbeg\n");
  
  cg_initialize(argc, argv);
}

/* 	int i; */

/* 	density = 1.1; */
/* 	ILtypes = newtable(PERM); */
/* 	{ */
/* 		extern int getpid(void); */
/* 		time_t t, prev = time(NULL); */
/* 		while ((t = time(NULL)) == prev) */
/* 			; */
/* 		uname = stringf("%x_%x_", t, getpid()); */
/* 	} */
/* 	for (i = 0; i < argc; i++) */
/* 		if (strncmp(argv[i], "-uname=", 7) == 0) */
/* 			uname = argv[i] + 7; */
/* 	print("//"); */
/* 	if (firstfile != NULL) */
/* 		print(" file=%s", firstfile); */
/* 	print(" uname=%s\n", uname); */
/* } */

static void I(progend)(void) {
  if(OPT_C_DEBUG)
    print("@progend\n");
  
  cg_finalize();
}
/* 	closedata(); */
/* 	if (initbuffer != NULL) { */
/* 		print(".method public hidebysig static void $$%s_init() cil managed {\n" */
/* 		      ".maxstack 3\n", uname); */
/* 		printlist(&initbuffer); */
/* 		print("ret\n}\n"); */
/* 		print("//$$INIT call void $$%s_init()\n", uname); */
/* 	} */
/* } */

Interface optIR = {
	1, 1, 0,	/* char */
	2, 2, 0,	/* short */
	4, 4, 0,	/* int */
	4, 4, 0,	/* long */
	4, 4, 0,	/* long long */
	4, 4, 0,	/* float */
	8, 4, 0,	/* double */
	8, 4, 0,	/* long double */
	4, 4, 0,	/* T * */
	0, 1, 0,	/* struct; so that ARGB keeps stack aligned */
	1,		/* little_endian */
	0,		/* mulops_calls */
	0,		/* wants_callb */
	0,		/* wants_argb */
	1,		/* left_to_right */
	1,		/* wants_dag */
	0,		/* unsigned_char */
	0,		/* I(address) */
	I(blockbeg),
	I(blockend),
	I(defaddress),
	I(defconst),
	I(defstring),
	I(defsymbol),
	I(emit),
	I(export),
	I(function),
	I(gen),
	I(global),
	I(import),
	I(local),
	I(progbeg),
	I(progend),
	I(segment),
	I(space),
	0,		/* I(stabblock) */
	0,		/* I(stabend) */
	0,		/* I(stabfend) */
	0,		/* I(stabinit) */
	0,		/* I(stabline) */
	0,		/* I(stabsym) */
	0,		/* I(stabtype) */
};

#undef I
